routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CompanieController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\Auth\SocialiteController;
use App\Http\Controllers\ItemController;
use App\Http\Controllers\SellController;
use App\Http\Controllers\SellSummaryController;
use App\Jobs\SendEmailJob;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes([
    'register' => false
]);

Route::get('/auth/redirect/{provider}',[SocialiteController::class,'redirect'])->name('auth.redirect');
Route::get('/auth/callback/{provider}',[SocialiteController::class,'callback'])->name('auth.callback');

Route::middleware('auth')->group(function(){
    
    Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => App\Http\Controllers\LanguageController::class,'switch']);

    Route::get('/', function () {
        return view('home');
    });

    Route::get('tz/{tz}', ['as' => 'tz.switch', 'uses' => App\Http\Controllers\TimezoneController::class,'switch']);

    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('employees',EmployeeController::class)->except(['destroy']);
    Route::resource('sells',SellController::class)->except(['destroy']);
    Route::get('/employees/{employee}/destroy',[EmployeeController::class,'destroy'])->name('employees.destroy');
    
    Route::resource('companies',CompanieController::class)->except(['destroy']);
    Route::resource('items',ItemController::class)->except(['destroy']);
    Route::resource('sellSummaries',SellSummaryController::class)->except(['destroy']);
    Route::get('/items/{item}/destroy',[ItemController::class,'destroy'])->name('items.destroy');
    Route::get('/sells/{sell}/destroy',[SellController::class,'destroy'])->name('sells.destroy');

    Route::get('/companies/{company}/destroy',[CompanieController::class,'destroy'])->name('companies.destroy');
    
    Route::get('test/email', function(){
        $send_mail = 'lim.liete@gmail.com';
        dispatch(new App\Jobs\SendEmailJob($send_mail));
        dd('send mail successfully !!');
    })->name('sendEmail');
    

    

});

app/Models/Companie.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Companie extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'email',
        'logo',
        'website',
        'created_by_id',
        'updated_by_id'
    ];

    public function employees(){
        return $this->hasMany(Employee::class);
    }
    public function sellSummaries(){
        return $this->hasMany(SellSummary::class);
    }
}

app/Http/Controllers/CompanieController.php
<?php

namespace App\Http\Controllers;

use Spatie\Image\Image;
use App\Models\Companie;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use App\Http\Requests\CompanieStoreRequest;
use App\Jobs\comp;
use App\Jobs\SendEmailJob;
use Carbon\Carbon;
use Exception;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;

class CompanieController extends Controller
{
    public $logoName;

    public function resize_logo($logo){

        $this->logoName = time() . '.' . $logo->extension();
        $path = $logo->storeAs('public/logos',$this->logoName);

        //resize logo with spatie
        Image::load(public_path('storage/logos') . '/' . $this->logoName)->width(100)->height(100)->save();
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        
        // $companies = Companie::latest()->paginate(10);
        // return view('companie.index',compact('companies'));
        return view('companie.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('companie.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CompanieStoreRequest $request)
    {
        //store logo
        if($request->hasFile('logo')){
            $logo = $request->file('logo');
            //resize logo function
            $this->resize_logo($logo);
        }else{
            $this->logoName = 'default.jpg';
        }

        
        Companie::create([
            'name' => $request->name,
            'email' => $request->email,
            'logo' => $this->logoName,
            'website' => $request->website,
            'created_by_id' => $request->created_by_id,
            'updated_by_id' => $request->updated_by_id
        ]);
        $send_mail = $request->email;
        dispatch(new SendEmailJob($send_mail));
        return redirect()->route('companies.create')->with('message',['text' => __('companie.status2'), 'class' => 'success']);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Companie $company)
    {
        return view('companie.edit',compact('company'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(CompanieStoreRequest $request, Companie $company)
    {
        //store logo
        if($request->hasFile('logo')){
            $logo = $request->file('logo');
            //resize image function
            $this->resize_logo($logo);
        }else if($company->logo != null){
            $this->logoName = $company->logo;
        }else{
            $this->logoName = 'default.jpg';
        }

        $company->update([
            'name' => $request->name,
            'email' => $request->email,
            'logo' => $this->logoName,
            'website' => $request->website,
            'updated_by_id' =>$request->updated_by_id
        ]);

        return redirect()->route('companies.edit',$company->id)->with('message',['text' => __('companie.status3'), 'class' => 'success']);

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Companie $company)
    {
        $company->delete();
        return redirect()->route('companies.index')->with('message',['text' => __('companie.status4'), 'class' => 'success']);
    }

}

app/View/Components/Companies.php
<?php

namespace App\View\Components;

use App\Models\Companie;
use Illuminate\View\Component;


class Companies extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $companies = Companie::count();
        return view('components.companies',compact('companies'));
    }
}

resources/views/companie/create.blade.php
@extends('layouts.app')
@section('title')
{{ trans('companie.title2') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

      @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ trans('companie.title2') }}
                    <a href="{{ route('companies.index') }}" class="btn btn-sm btn-secondary float-right">{{ trans('companie.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('companies.store') }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        <div class="row">
                          <div class="col-6">
                            <label for="">{{ trans('companie.table1') }}</label>
                            <input type="text" class="form-control" name="name" value="{{ old('name') }}">
                            @include('layouts.error', ['name' => 'name'])
                          </div>
                          <div class="col-6">
                            <label for="">{{ trans('companie.table2') }}</label>
                            <input type="email" class="form-control" name="email" value="{{ old('email') }}">
                            @include('layouts.error', ['name' => 'email'])
                        </div>
                      </div>
                      <div class="row mt-3">
                            <div class="col-6">
                                <img id="output" src="" width="100" height="100" alt="Logo Preview" class="img-thumbnail">
                                <div class="custom-file mt-3">
                                    <input type="file" name="logo" class="custom-file-input" accept="image/*" onchange="document.getElementById('output').src = window.URL.createObjectURL(this.files[0])">
                                    @include('layouts.error', ['name' => 'logo'])
                                    <label for="" class="custom-file-label">{{ trans('companie.table3') }}</label>
                                </div>
                            </div>
                            <div class="col-6 ">
                                <label for="">{{ trans('companie.table4') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="website" class="form-control" value="{{ old('website') }}">
                                    @include('layouts.error', ['name' => 'website'])
                                </div>
                            </div>
                            <div class="col-6 " style="display: none;">
                                <label for="">{{ __('Created By Id') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="created_by_id" class="form-control" value="{{ Auth::id() }}">
                                    @include('layouts.error', ['name' => 'created_by_id'])
                                </div>
                            </div>
                            <div class="col-6 " style="display: none;">
                                <label for="">{{ __('Updated By Id') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="updated_by_id" class="form-control" value="{{ Auth::id() }}">
                                    @include('layouts.error', ['name' => 'updated_by_id'])
                                </div>
                            </div>
                      </div>
                      <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit">{{ trans('companie.btn1') }}</button>
                      </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/companie/edit.blade.php
@extends('layouts.app')
@section('title')
{{ trans('companie.title3') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

      @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                    {{ trans('companie.title3') }}
                    <a href="{{ route('companies.index') }}" class="btn btn-sm btn-secondary float-right"> {{ trans('companie.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('companies.update',$company->id) }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')
                        <div class="row">
                          <div class="col-6">
                            <label for=""> {{ trans('companie.table1') }}</label>
                            <input type="text" class="form-control" name="name" value="{{ $company->name }}">
                            @include('layouts.error', ['name' => 'name'])
                          </div>
                          <div class="col-6">
                            <label for=""> {{ trans('companie.table2') }}</label>
                            <input type="email" class="form-control" name="email" value="{{ $company->email }}">
                            @include('layouts.error', ['name' => 'email'])
                        </div>
                      </div>
                      <div class="row mt-3">
                            <div class="col-6">
                                <img id="output" src="{{ Storage::url('logos/' . $company->logo) }}" width="100" height="100" alt="Logo Preview" class="img-thumbnail">
                                <div class="custom-file mt-3">
                                    <input type="file" name="logo" class="custom-file-input" accept="image/*" onchange="document.getElementById('output').src = window.URL.createObjectURL(this.files[0])">
                                    @include('layouts.error', ['name' => 'logo'])
                                    <label for="" class="custom-file-label"> {{ trans('companie.table3') }}</label>
                                </div>
                            </div>
                            <div class="col-6 ">
                                <label for=""> {{ trans('companie.table4') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="website" class="form-control" value="{{ $company->website }}">
                                    @include('layouts.error', ['name' => 'website'])
                                </div>
                            </div>
                            <div class="col-6 " style="display: none;">
                                <label for="">{{ __('Created By Id') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="created_by_id" class="form-control" value="{{ $company->created_by_id }}">
                                    @include('layouts.error', ['name' => 'created_by_id'])
                                </div>
                            </div>
                            <div class="col-6 " style="display: none;">
                                <label for="">{{ __('Updated By Id') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="updated_by_id" class="form-control" value="{{ Auth::id() }}">
                                    @include('layouts.error', ['name' => 'updated_by_id'])
                                </div>
                            </div>
                      </div>
                      <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit"> {{ trans('companie.btn5') }}</button>
                      </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/companie/index.blade.php
@extends('layouts.app')
@section('title')
    {{ trans('companie.title1') }}
@endsection
@section('content')
    <div class="container">
        <div class="row justify-content-center">

            @include('layouts.notif')

            <div class="col-md-12 mt-2">
                <div class="card">
                    <div class="card-header">
                        {{ trans('companie.title1') }}
                        <a href="{{ route('companies.create') }}"
                            class="btn btn-sm btn-primary float-right">{{ trans('companie.btn1') }}</a>
                    </div>
                    <div class="card-body">
                        <br>
                        <!-- MULAI DATE RANGE PICKER -->
                        <div class="row input-daterange">
                            <div class="col-md-6">
                                <input type="text" name="from_date" id="from_date" class="form-control"
                                    placeholder="{{ trans('companie.fromdate') }}" readonly />
                            </div>
                            <div class="col-md-6">
                                <input type="text" name="to_date" id="to_date" class="form-control"
                                    placeholder="{{ trans('companie.todate') }}" readonly />
                            </div>
                            
                        </div>
                        <!-- AKHIR DATE RANGE PICKER -->
                        <br>
                        <div class="row">
                            <div class="col-md-4">
                                <input type="text" class="form-control filter-input" id="name" name="name"
                                    placeholder="{{ trans('companie.filtername') }}" data-column="1" />
                            </div>
                            <div class="col-md-4">
                                <input type="text" class="form-control filter-input" id="email" name="email"
                                    placeholder="{{ trans('companie.filteremail') }}" data-column="2" />
                            </div>
                            <div class="col-md-4">
                                <input type="text" class="form-control filter-input" id="website" name="website"
                                    placeholder="{{ trans('companie.filterwebsite') }}" data-column="4" />
                            </div>

                        </div>
                        <br>
                        <div class="row">
                            <div class="col-md" style="text-align: end">
                                <button type="button" name="filter" id="filter"
                                    class="btn btn-primary">{{ trans('companie.btn6') }}</button>
                                <button type="button" name="refresh" id="refresh"
                                    class="btn btn-default">{{ trans('companie.btn7') }}</button>
                            </div>
                        </div>

                        <br>
                        <table class="table text-center table-bordered table-striped" id="CompaniesTable">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>{{ trans('companie.table1') }}</th>
                                    <th>{{ trans('companie.table2') }}</th>
                                    <th>{{ trans('companie.table3') }}</th>
                                    <th>{{ trans('companie.table4') }}</th>
                                    <th>{{ trans('companie.table5') }}</th>
                                    <th>{{ trans('companie.table6') }}</th>
                                    <th>{{ trans('companie.table7') }}</th>
                                </tr>
                            </thead>
                            <tbody>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>



        </div>
    </div>
@endsection
@section('script')
    <!-- MULAI DATEPICKER JS -->
    <link rel="stylesheet"
        href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/css/bootstrap-datepicker.min.css">

    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/js/bootstrap-datepicker.js"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            $.noConflict();
            var table = $('#CompaniesTable').DataTable({
                "processing": true,
                "serverSide": true,
                "dom": "lrtpi",
                "responsive": true,
                ajax: {
                    url: "{{ route('api.companies') }}",
                    type: 'GET',
                    data: {
                        region: "{{ Session::get('tz') }}"
                    } //jangan lupa kirim parameter tanggal 
                },
                "columns": [{
                        "data": "DT_RowIndex",
                        name: 'DT_RowIndex'
                    },
                    {
                        "data": "name"
                    },
                    {
                        "data": "email"
                    },
                    {
                        "data": "image",
                        name: 'image',
                        orderable: false,
                        searchable: false
                    },
                    {
                        "data": "website"
                    },
                    {
                        "data": "created_at"
                    },
                    {
                        "data": "updated_at"
                    },
                    {
                        "data": "action",
                        name: 'action',
                        orderable: false,
                        searchable: false
                    }
                ]
            });
            // $('.filter-input').keyup(function() {
            //     table.column($(this).data('column'))
            //         .search($(this).val())
            //         .draw();
            // });
        });
    </script>
    <script>
        //jalankan function load_data diawal agar data ter-load
        // load_data();
        //Iniliasi datepicker pada class input
        $('.input-daterange').datepicker({
            todayBtn: 'linked',
            format: 'yyyy-mm-dd',
            autoclose: true
        });
        $('#filter').click(function() {
            var from_date = $('#from_date').val();
            var to_date = $('#to_date').val();
            var name = $('#name').val();
            var email = $('#email').val();
            var website = $('#website').val();
            if (from_date != '' && to_date != '') {
                $('#CompaniesTable').DataTable().destroy();
                load_data(from_date, to_date, name, email, website);
            } else {
                $('#from_date').val('');
                $('#to_date').val('');
                $('#CompaniesTable').DataTable().destroy();
                load_data('', '', name, email, website);
            }
        });
        $('#refresh').click(function() {
            $('#from_date').val('');
            $('#to_date').val('');
            $('#name').val('');
            $('#email').val('');
            $('#website').val('');
            $('#CompaniesTable').DataTable().destroy();
            load_data();
        });



        function load_data(from_date = '', to_date = '', name = '', email = '', website = '') {
            var table = $('#CompaniesTable').DataTable({
                "processing": true,
                "dom": "lrtpi",
                "serverSide": true,
                "responsive": true,
                ajax: {
                    url: "{{ route('api.companies') }}",
                    type: 'GET',
                    data: {
                        from_date: from_date,
                        to_date: to_date,
                        name: name,
                        email: email,
                        website: website,
                        region: "{{ Session::get('tz') }}"
                    } //jangan lupa kirim parameter tanggal 
                },
                "columns": [{
                        "data": "DT_RowIndex",
                        name: 'DT_RowIndex'
                    },
                    {
                        "data": "name"
                    },
                    {
                        "data": "email"
                    },
                    {
                        "data": "image",
                        name: 'image',
                        orderable: false,
                        searchable: false
                    },
                    {
                        "data": "website"
                    },
                    {
                        "data": "created_at"
                    },
                    {
                        "data": "updated_at"
                    },
                    {
                        "data": "action",
                        name: 'action',
                        orderable: false,
                        searchable: false
                    }
                ]

            });
            // $('.filter-input').keyup(function() {
            //     table.column($(this).data('column'))
            //         .search($(this).val())
            //         .draw();
            // });
        };
    </script>
@endsection